﻿//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated from a template.
//
//     Manual changes to this file may cause unexpected behavior in your application.
//     Manual changes to this file will be overwritten if the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

namespace ASHNA.Models
{
    using System;
    using System.Data.Entity;
    using System.Data.Entity.Infrastructure;
    using System.Data.Entity.Core.Objects;
    using System.Linq;
    
    public partial class ASHNAEntities : DbContext
    {
        public ASHNAEntities()
            : base("name=ASHNAEntities")
        {
        }
    
        protected override void OnModelCreating(DbModelBuilder modelBuilder)
        {
            throw new UnintentionalCodeFirstException();
        }
    
        public virtual DbSet<addNew> addNews { get; set; }
        public virtual DbSet<Group> Groups { get; set; }
        public virtual DbSet<GroupsRole> GroupsRoles { get; set; }
        public virtual DbSet<Role> Roles { get; set; }
        public virtual DbSet<Setting> Settings { get; set; }
        public virtual DbSet<Tbl_Customers> Tbl_Customers { get; set; }
        public virtual DbSet<tbl_Security> tbl_Security { get; set; }
        public virtual DbSet<User> Users { get; set; }
        public virtual DbSet<UsersGroup> UsersGroups { get; set; }
    
        public virtual ObjectResult<SP_CustomersAuthentication_Result> SP_CustomersAuthentication(string username, string password)
        {
            var usernameParameter = username != null ?
                new ObjectParameter("Username", username) :
                new ObjectParameter("Username", typeof(string));
    
            var passwordParameter = password != null ?
                new ObjectParameter("Password", password) :
                new ObjectParameter("Password", typeof(string));
    
            return ((IObjectContextAdapter)this).ObjectContext.ExecuteFunction<SP_CustomersAuthentication_Result>("SP_CustomersAuthentication", usernameParameter, passwordParameter);
        }
    
        public virtual ObjectResult<SP_CustomersInformation_Result> SP_CustomersInformation(Nullable<int> personalCode, string password, Nullable<int> supervisor, string name, string family, Nullable<int> firstUserAccount, string phone, string cellPhone, string email, Nullable<System.DateTime> birthdayDate, Nullable<System.DateTime> membershipDate, string address, string fatherName, string nationalCode)
        {
            var personalCodeParameter = personalCode.HasValue ?
                new ObjectParameter("PersonalCode", personalCode) :
                new ObjectParameter("PersonalCode", typeof(int));
    
            var passwordParameter = password != null ?
                new ObjectParameter("Password", password) :
                new ObjectParameter("Password", typeof(string));
    
            var supervisorParameter = supervisor.HasValue ?
                new ObjectParameter("Supervisor", supervisor) :
                new ObjectParameter("Supervisor", typeof(int));
    
            var nameParameter = name != null ?
                new ObjectParameter("Name", name) :
                new ObjectParameter("Name", typeof(string));
    
            var familyParameter = family != null ?
                new ObjectParameter("Family", family) :
                new ObjectParameter("Family", typeof(string));
    
            var firstUserAccountParameter = firstUserAccount.HasValue ?
                new ObjectParameter("FirstUserAccount", firstUserAccount) :
                new ObjectParameter("FirstUserAccount", typeof(int));
    
            var phoneParameter = phone != null ?
                new ObjectParameter("Phone", phone) :
                new ObjectParameter("Phone", typeof(string));
    
            var cellPhoneParameter = cellPhone != null ?
                new ObjectParameter("CellPhone", cellPhone) :
                new ObjectParameter("CellPhone", typeof(string));
    
            var emailParameter = email != null ?
                new ObjectParameter("Email", email) :
                new ObjectParameter("Email", typeof(string));
    
            var birthdayDateParameter = birthdayDate.HasValue ?
                new ObjectParameter("BirthdayDate", birthdayDate) :
                new ObjectParameter("BirthdayDate", typeof(System.DateTime));
    
            var membershipDateParameter = membershipDate.HasValue ?
                new ObjectParameter("MembershipDate", membershipDate) :
                new ObjectParameter("MembershipDate", typeof(System.DateTime));
    
            var addressParameter = address != null ?
                new ObjectParameter("Address", address) :
                new ObjectParameter("Address", typeof(string));
    
            var fatherNameParameter = fatherName != null ?
                new ObjectParameter("FatherName", fatherName) :
                new ObjectParameter("FatherName", typeof(string));
    
            var nationalCodeParameter = nationalCode != null ?
                new ObjectParameter("nationalCode", nationalCode) :
                new ObjectParameter("nationalCode", typeof(string));
    
            return ((IObjectContextAdapter)this).ObjectContext.ExecuteFunction<SP_CustomersInformation_Result>("SP_CustomersInformation", personalCodeParameter, passwordParameter, supervisorParameter, nameParameter, familyParameter, firstUserAccountParameter, phoneParameter, cellPhoneParameter, emailParameter, birthdayDateParameter, membershipDateParameter, addressParameter, fatherNameParameter, nationalCodeParameter);
        }
    
        public virtual ObjectResult<SP_CustomSecurity_Result> SP_CustomSecurity(Nullable<int> id, string username, string password, string name, string family, string email, string phone)
        {
            var idParameter = id.HasValue ?
                new ObjectParameter("id", id) :
                new ObjectParameter("id", typeof(int));
    
            var usernameParameter = username != null ?
                new ObjectParameter("username", username) :
                new ObjectParameter("username", typeof(string));
    
            var passwordParameter = password != null ?
                new ObjectParameter("Password", password) :
                new ObjectParameter("Password", typeof(string));
    
            var nameParameter = name != null ?
                new ObjectParameter("name", name) :
                new ObjectParameter("name", typeof(string));
    
            var familyParameter = family != null ?
                new ObjectParameter("family", family) :
                new ObjectParameter("family", typeof(string));
    
            var emailParameter = email != null ?
                new ObjectParameter("Email", email) :
                new ObjectParameter("Email", typeof(string));
    
            var phoneParameter = phone != null ?
                new ObjectParameter("Phone", phone) :
                new ObjectParameter("Phone", typeof(string));
    
            return ((IObjectContextAdapter)this).ObjectContext.ExecuteFunction<SP_CustomSecurity_Result>("SP_CustomSecurity", idParameter, usernameParameter, passwordParameter, nameParameter, familyParameter, emailParameter, phoneParameter);
        }
    
        public virtual ObjectResult<USP_AddUser_Result> USP_AddUser(Nullable<int> accountID, string password, string firstName, string lastName, string email, string phone, string cellPhone, string birthdayDate, string membershipDate, string address, string fatherName, string nationalCode)
        {
            var accountIDParameter = accountID.HasValue ?
                new ObjectParameter("AccountID", accountID) :
                new ObjectParameter("AccountID", typeof(int));
    
            var passwordParameter = password != null ?
                new ObjectParameter("Password", password) :
                new ObjectParameter("Password", typeof(string));
    
            var firstNameParameter = firstName != null ?
                new ObjectParameter("FirstName", firstName) :
                new ObjectParameter("FirstName", typeof(string));
    
            var lastNameParameter = lastName != null ?
                new ObjectParameter("LastName", lastName) :
                new ObjectParameter("LastName", typeof(string));
    
            var emailParameter = email != null ?
                new ObjectParameter("Email", email) :
                new ObjectParameter("Email", typeof(string));
    
            var phoneParameter = phone != null ?
                new ObjectParameter("Phone", phone) :
                new ObjectParameter("Phone", typeof(string));
    
            var cellPhoneParameter = cellPhone != null ?
                new ObjectParameter("CellPhone", cellPhone) :
                new ObjectParameter("CellPhone", typeof(string));
    
            var birthdayDateParameter = birthdayDate != null ?
                new ObjectParameter("BirthdayDate", birthdayDate) :
                new ObjectParameter("BirthdayDate", typeof(string));
    
            var membershipDateParameter = membershipDate != null ?
                new ObjectParameter("MembershipDate", membershipDate) :
                new ObjectParameter("MembershipDate", typeof(string));
    
            var addressParameter = address != null ?
                new ObjectParameter("Address", address) :
                new ObjectParameter("Address", typeof(string));
    
            var fatherNameParameter = fatherName != null ?
                new ObjectParameter("FatherName", fatherName) :
                new ObjectParameter("FatherName", typeof(string));
    
            var nationalCodeParameter = nationalCode != null ?
                new ObjectParameter("nationalCode", nationalCode) :
                new ObjectParameter("nationalCode", typeof(string));
    
            return ((IObjectContextAdapter)this).ObjectContext.ExecuteFunction<USP_AddUser_Result>("USP_AddUser", accountIDParameter, passwordParameter, firstNameParameter, lastNameParameter, emailParameter, phoneParameter, cellPhoneParameter, birthdayDateParameter, membershipDateParameter, addressParameter, fatherNameParameter, nationalCodeParameter);
        }
    
        public virtual ObjectResult<USP_Authenticate_Result> USP_Authenticate(string username, string password)
        {
            var usernameParameter = username != null ?
                new ObjectParameter("Username", username) :
                new ObjectParameter("Username", typeof(string));
    
            var passwordParameter = password != null ?
                new ObjectParameter("Password", password) :
                new ObjectParameter("Password", typeof(string));
    
            return ((IObjectContextAdapter)this).ObjectContext.ExecuteFunction<USP_Authenticate_Result>("USP_Authenticate", usernameParameter, passwordParameter);
        }
    }
}
